# class JSON::Builder

- JSON::Builder
- Reference
- Object

##
Overview

A JSON builder generates valid JSON.

A `JSON::Error` is raised if attempting to generate an invalid JSON (for example, if invoking `#end_array` without a matching `#start_array`, or trying to use a non-string value as an object's field name).

##
Defined in:

##
Constructors

- .new(io : IO)

  Creates a `JSON::Builder` that will write to the given `IO`.

##
Instance Method Summary

- #array(&)

  Writes the start of an array, invokes the block, and the writes the end of it.

- #bool(value : Bool)

  Writes a boolean value.

- #document(&)
- #end_array

  Writes the end of an array.

- #end_document : Nil

  Signals the end of a JSON document.

- #end_object

  Writes the end of an object.

- #field(name, &)

  Writes an object's field and then invokes the block.

- #field(name, value)

  Writes an object's field and value.

- #flush

  Flushes the underlying `IO`.

- #indent=(level : Int)

  Sets the indent level (number of spaces).

- #indent=(string : String)

  Sets the indent string.

- #max_nesting : Int32

  By default the maximum nesting of arrays/objects is 99.

- #max_nesting=(max_nesting)

  By default the maximum nesting of arrays/objects is 99.

- #next_is_object_key? : Bool

  Returns `true` if the next thing that must pushed into this builder is an object key (so a string) or the end of an object.

- #null

  Writes a `#null` value.

- #number(number : Float)

  Writes a float.

- #number(number : Int)

  Writes an integer.

- #object(&)

  Writes the start of an object, invokes the block, and the writes the end of it.

- #raw(string : String)

  Writes a raw value, considered a scalar, directly into the IO without processing.

- #scalar(value : Nil)

  Writes a scalar value.

- #scalar(value : Bool)

  Writes a scalar value.

- #scalar(value : Int | Float)

  Writes a scalar value.

- #scalar(value : String)

  Writes a scalar value.

- #start_array

  Writes the start of an array.

- #start_document

  Starts a document.

- #start_object

  Writes the start of an object.

- #string(value)

  Writes a string.

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference)
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new

### Instance methods inherited from class `Object`

!=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, __crystal_pseudo_! : Bool __crystal_pseudo_!, __crystal_pseudo_as(type : Class) __crystal_pseudo_as, __crystal_pseudo_as?(type : Class) __crystal_pseudo_as?, __crystal_pseudo_is_a?(type : Class) : Bool __crystal_pseudo_is_a?, __crystal_pseudo_nil? : Bool __crystal_pseudo_nil?, __crystal_pseudo_responds_to?(name : Symbol) : Bool __crystal_pseudo_responds_to?, class class, dup dup, hash(hasher)
hash hash, inspect : String
inspect(io : IO) : Nil inspect, itself itself, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, tap(&) tap, to_json(io : IO)
to_json to_json, to_pretty_json(indent : String = " ")
to_pretty_json(io : IO, indent : String = " ") to_pretty_json, to_s : String
to_s(io : IO) : Nil to_s, to_yaml(io : IO)
to_yaml to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io, root : String)
from_json(string_or_io) from_json, from_yaml(string_or_io : String | IO) from_yaml

##
Constructor Detail

def self.new(io : IO) #

Creates a `JSON::Builder` that will write to the given `IO`.

##
Instance Method Detail

def array(&) #

Writes the start of an array, invokes the block, and the writes the end of it.

def bool(value : Bool) #

Writes a boolean value.

def document(&) #
def end_array #

Writes the end of an array.

def end_document : Nil #

Signals the end of a JSON document.

def end_object #

Writes the end of an object.

def field(name, &) #

Writes an object's field and then invokes the block. This is equivalent of invoking `#string(value)` and then invoking the block.

def field(name, value) #

Writes an object's field and value. The field's name is first converted to a `String` by invoking `to_s` on it.

def flush #

Flushes the underlying `IO`.

def indent=(level : Int) #

Sets the indent level (number of spaces).

def indent=(string : String) #

Sets the indent string.

def max_nesting : Int32 #

By default the maximum nesting of arrays/objects is 99. Nesting more than this will result in a JSON::Error. Changing the value of this property allows more/less nesting.

def max_nesting=(max_nesting) #

By default the maximum nesting of arrays/objects is 99. Nesting more than this will result in a JSON::Error. Changing the value of this property allows more/less nesting.

def next_is_object_key? : Bool #

Returns `true` if the next thing that must pushed into this builder is an object key (so a string) or the end of an object.

def null #

Writes a `#null` value.

def number(number : Float) #

Writes a float.

def number(number : Int) #

Writes an integer.

def object(&) #

Writes the start of an object, invokes the block, and the writes the end of it.

def raw(string : String) #

Writes a raw value, considered a scalar, directly into the IO without processing. This is the only method that might lead to invalid JSON being generated, so you must be sure that string contains a valid JSON string.

def scalar(value : Nil) #

Writes a scalar value.

def scalar(value : Bool) #

Writes a scalar value.

def scalar(value : Int | Float) #

Writes a scalar value.

def scalar(value : String) #

Writes a scalar value.

def start_array #

Writes the start of an array.

def start_document #

Starts a document.

def start_object #

Writes the start of an object.

def string(value) #

Writes a string. The given value is first converted to a `String` by invoking `to_s` on it.

This method can also be used to write the name of an object field.